<template>
    <div>
        <h1>Gestion de club - {{ nomClub }}</h1>
        <div>
            <h2>Demandes de rejoindre le club</h2>
            <table class="uk-table uk-table-striped">
                <thead>
                    <tr>
                        <th>Nom</th>
                        <th>Prénom</th>
                        <th>Date de la demande</th>
                        <th>Accepter</th>
                        <th>Refuser</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="demande in demandes" :key="demande.id">
                        <td>{{ demande.demandeur.nom }}</td>
                        <td>{{ demande.demandeur.prenom }}</td>
                        <td>{{ demande.date }}</td>
                        <td>
                            <span
                                class="uk-margin-small-right"
                                uk-icon="icon: check; ratio: 1"
                                @click="accepter(demande.id)"
                            ></span>
                        </td>
                        <td>
                            <span
                                class="uk-margin-small-right"
                                uk-icon="icon: close; ratio: 1"
                                @click="refuser(demande.id)"
                            ></span>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div>
            <h2>Elèves du club</h2>
            <table class="uk-table uk-table-striped">
                <thead>
                    <tr>
                        <th>Nom</th>
                        <th>Prénom</th>
                        <th>Date d'inscription</th>
                        <th>Désinscrire</th>
                    </tr>
                </thead>
                <tbody>
                    <tr
                        v-for="inscription in inscriptions"
                        :key="inscription.id"
                    >
                        <td>{{ inscription.eleve.nom }}</td>
                        <td>{{ inscription.eleve.prenom }}</td>
                        <td>
                            {{ inscription.dateInscription }}
                        </td>
                        <td>
                            <span
                                uk-icon="icon: close; ratio: 1"
                                @click="desinscrire(inscription.id)"
                            />
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Axios from '@/auth/axiosAuth';
import Component from 'vue-class-component';
import UtilisateurSorter from '@/components/outils/UtilisateurSorter';
import { getInstance } from '@/auth/auth';
import Utilisateur from '../../classes/Utilisateur';
@Component
export default class AffectationClub extends Vue {
    private nomClub = '';
    private inscriptions: any[] = [];
    private demandes: any[] = [];

    async beforeRouteEnter(to, from, next) {
        const authService = getInstance();
        const data: Record<any, any> = await new Promise((resolve) => {
            Axios.get('gestionclub/' + authService.user.idClub, (response) => {
                resolve(response.data);
            });
        });
        const inscriptions = data.inscriptions;
            UtilisateurSorter.comparerListeSelonUtilisateur(
                inscriptions,
                (inscription) => Object.assign(new Utilisateur(), inscription.eleve)
            );
            const demandes = data.demandes;
            UtilisateurSorter.comparerListeSelonUtilisateur(
                demandes,
                (demande) => Object.assign(new Utilisateur(), demande.demandeur),
            );
        next((vm) => {
            vm.nomClub = data.nomClub;
            vm.inscriptions = inscriptions;
            vm.demandes = demandes;
        });
    }

    public accepter(id: string) {
        Axios.post('gestionclub/acceptation/' + id, (response) => {
            this.demandes = this.demandes.filter((demande) => demande.id != id);
            this.inscriptions.push(response.data);
        });
    }

    public refuser(id: string) {
        Axios.post('gestionclub/refus/' + id, () => {
            this.demandes = this.demandes.filter((demande) => demande.id != id);
        });
    }

    public desinscrire(id: string) {
        Axios.post('gestionclub/desinscription/' + id, () => {
            this.inscriptions = this.inscriptions.filter(
                (inscription) => inscription.id != id,
            );
        });
    }
}
</script>
